function cip_counts=AnalyzePredicates_nr(predicates_sets)
% cip_counts=AnalyzePredicates_nr(predicates_sets)
% Estimate the number of distinct cell index pairs in a number of predicate
% sets.
%
% Developer: Shujun Li @ www.hooklee.com, 2009.

if nargin<1
    disp('DisplayPredicates: at least one input parameter is needed!');
    return;
end

nr=numel(predicates_sets);

cip_counts=zeros(1,nr);
for i=1:nr
    s_i=numel(predicates_sets{i});
    cips=zeros(1,s_i);
    for j=1:s_i
        cips(j)=Predicate2CellIndex(predicates_sets{i}{j});
    end
    cip_counts(i)=numel(unique(cips));
end
