function DisplayBrokenPassword(BrokenPassword)
% DisplayBrokenPassword(BrokenPassword)
% Display a broken password (cell index is fixed, but secret characters may 
% not be) stored in a 1X(len+1) cell array.
%
% Developer: Shujun Li @ www.hooklee.com, 2009.

if nargin<1
    disp('DisplayBrokenPassword: one input argument is needed!');
    return;
end
if isempty(BrokenPassword)
    disp('DisplayBrokenPassword: the given set of passwords is empty!');
    return;
end

len_plus_1=numel(BrokenPassword);
for i=1:2
    fprintf('(%d,%d)',BrokenPassword{1}(i,1:2));
    for j=2:len_plus_1
        password_j_size2=size(BrokenPassword{j},2);
        if password_j_size2==0
            fprintf('*');
        else
            if password_j_size2>1
                fprintf('[');
            end
            for k=1:password_j_size2
                fprintf('%c',BrokenPassword{j}(i,k)+'A'-1);
            end
            if password_j_size2>1
                fprintf(']');
            end
        end
    end
    fprintf('\n');
end
