function DisplayBrokenPasswords(passwords)
% Display a set of broken passwords stored in a cell array.
% These passwords may be of different sizes.
%
% Developer: Shujun Li @ www.hooklee.com, 2009.

if nargin<1
    disp('DisplayBrokenPasswords: one input argument is needed!');
    return;
end
if isempty(passwords)
    disp('DisplayBrokenPasswords: the given set of passwords is empty!');
    return;
end

s=numel(passwords);

for i=1:s
    fprintf('=====Password %d:=====\n',i);
    password=passwords{i};
    len_plus_1=numel(password);
    for j=1:2
        fprintf('(%d,%d)',password{1}(j,1:2));
        for k=2:len_plus_1
            password_k_size2=size(password{k},2);
            if password_k_size2==0
                fprintf('*');
            else
                if password_k_size2>1
                    fprintf('[');
                end
                for ii=1:password_k_size2
                    fprintf('%c',password{k}(j,ii)+'A'-1);
                end
                if password_k_size2>1
                    fprintf(']');
                end
            end
        end
        fprintf('\n');
    end
end
