function DisplayChallenge(challenge)
% DisplayChallenge(challenge)
% Display a given challenge.
%
% Developer: Shujun Li @ www.hooklee.com, 2009.

if nargin<1
    disp('DisplayChallenge: One input parameter is required as the challenge to be displayed!');
    return;
end
if numel(size(challenge))~=3
    disp('DisplayChallenge: the input challenge is not valid!');
    return;
end

[m n l]=size(challenge);
m_len=ceil(log10(m));
n_len=ceil(log10(n));

for i1=1:l % table
    fprintf('--Challenge Table %d--\n',i1);
    for i2=1:m % row
        for i3=1:n
            fprintf('(%*d,%*d):',m_len,i2,n_len,i3);
            fprintf('%c',challenge{i2,i3,i1}(:)+'A'-1);
            fprintf('  ');
        end
        fprintf('\n');
    end
end
