function DisplayPredicatesSetAttack(predicates_sets,predicates)
% DisplayPredicatesSetRefined(predicates_sets,predicates)
% Display a number of predicate sets as the results of an attack.
%
% Developer: Shujun Li @ www.hooklee.com, 2009.

if nargin<1
    disp('DisplayPredicatesSetRefined: at least one input argument is needed!');
    return;
end

if nargin<2
    predicates=[];
end

na=numel(predicates_sets);

% Display sizes of refined predicate sets.
s=zeros(1,na);
for i=1:na
    s(i)=numel(predicates_sets{i});
    fprintf('Predicate Set %d: size = %d\n',i,s(i));
end

% Display all predicates in the refined predicate sets.
% First display broken predicates.
index=find(s==1);
s_index=numel(index);
for i=1:s_index
    ii=index(i);
    predicate=predicates_sets{ii}{1};
    fprintf('Predicate %d is broken: (%d,%d)%c,(%d,%d)%c',ii,...
        predicate(1,1:2),predicate(1,3)+'A'-1,predicate(2,1:2),predicate(2,3)+'A'-1);
    if ~isempty(predicates)
        fprintf(' *****');
    end
    fprintf('\n');
end
% Next display other predicates with more than one candidates.
index2=setdiff(1:na,index);
s_index2=numel(index2);
for i=1:s_index2
    ii=index2(i);
    fprintf('Predicate %d is one of the following:\n',ii);
    for j=1:s(ii)
        predicate=predicates_sets{ii}{j};
        fprintf('  (%d,%d)%c,(%d,%d)%c',predicate(1,1:2),...
            predicate(1,3)+'A'-1,predicate(2,1:2),predicate(2,3)+'A'-1);
        if (~isempty(predicates) && all(all(predicate==predicates{ii})))
            fprintf(' *****');
        end
        fprintf('\n');
    end
end
