function [prob,count]=EstimateRankingStatistics(M,H,p,l,nr,t)
% [prob,count]=EstimateRankingStatistics(M,H,p,l,nr,t)
% Perform a number of random experiments to estimate the ranking
% probabilities and E(N_{max}).
% The experimental data shown in Row 2 of Tables 6 and 7 were calculated by
% this function.
%
% Developer: Shujun Li @ www.hooklee.com, 2009.

N=M^p;
N_1=N-1;
N1=(M*H)^p-1;
rho=0.4833961;
L=round(t*rho^t*N1/2^(l*nr));
q1=(H^p-1)/N1;
% q0=H^p/N1;

Test_Number=10000;

prob=0;
count=0;
for i=1:Test_Number
    Counter_q1=0;
    Counters_q0=zeros(1,N_1);
    for j=1:L
        if rand<=q1 % q1-object
            Counter_q1=Counter_q1+1;
        else
            index=randint(1,1,[1 N_1]); % Others uniformly distribute.
            Counters_q0(index)=Counters_q0(index)+1;
        end
    end
    max_count=max([Counter_q1+t Counters_q0]);
    if max_count==Counter_q1+t
        prob=prob+1;
    end
    count=count+sum([Counter_q1+t Counters_q0]==max_count);
end
prob=prob/Test_Number;
count=count/Test_Number;
