function challenge=GenerateChallenge(predicate,m,n,H,l,p)
% challenge=GenerateChallenge(predicate,m,n,H,l,p)
% Generate a challenge for one round of one authentication session.
% The output is an mXnXl cell matrix, whose element is a cell in a challenge table.
%
% Developer: Shujun Li @ www.hooklee.com, 2009.

if nargin<6
    p=2;
    if nargin<5
        l=2;
        if nargin<4
            H=26;
            if nargin<3
                n=5;
                if nargin<2
                    m=5;
                    if nargin<1
                        predicate=GeneratePredicate(m,n,H,p);
                    end
                end
            end
        end
    end
end

tau=ceil(H/2);
tau_1=tau-1; % floor(H/2)
beta=H/2-tau+1;
% Use cell array to represent each cell, since there may be different
% numbers of elements in different cells.
challenge=cell(m,n,l);
for i1=1:l
    for i2=1:m
        for i3=1:n
            temp=randperm(H);
            if beta==1 % mod(H,2)==0
                challenge{i2,i3,i1}=temp(1:tau);
            else
                if rand<=beta
                    challenge{i2,i3,i1}=temp(1:tau);
                else
                    challenge{i2,i3,i1}=temp(1:tau_1);
                end
            end
        end
    end
end

