function lq=GenerateLatinSquare(l)
% lq=GenerateLatinSquare(l)
% Generate a Latin Square of size 2^l.
%
% Developer: Shujun Li @ www.hooklee.com, 2009.

if nargin<1
    l=2;
end

l2=2^l;

% construct a Galois Filed array of order 2^l
t=gf([0 randperm(l2-1)],l);
k=myrand(l2-1)+1; % k cannot be 0
lq_gf=repmat(t(k)*t',1,l2)+repmat(t,l2,1); % a(i,j)=t(k)*t(i)+t(j);
% get data from the GF array
lq=lq_gf.x+1;
% randomize the latin square
lq=lq(randperm(l2),:);
lq=lq(:,randperm(l2));
