function predicate=GeneratePredicate(varargin)
% predicate=GeneratePredicate(m,n,H,p) or
% predicate=GeneratePredicate(password)
% Generate a random predicate from the system parameters or a password.
%
% The output is a pX3 matrix, whose three columns represent the 
% cell index and a secret character (actually a number between 1 and 26).
%
% Developer: Shujun Li @ www.hooklee.com, 2009.

predicate=[];

if (nargin>=1 && length(varargin{1})>2) % password should be a 2X(len+2) matrix
    password=varargin{1};
    p=size(password,1);
    if p<2
        disp('GeneratePredicate: the input argument is not a valid password!')
        return;
    elseif p>2
        p=2;% Curently, only p=2 is supported!
    end
    len_plus_2=size(password,2);
    len=len_plus_2-2;
    if nargin<2
        I=myrand(len);
    else
        I=varargin{2};
    end
    predicate=[password(1:p,1:2) password(1:p,2+I)];
    return;
elseif nargin<4
    p=2;
    if nargin<3
        H=26;
        if nargin<2
            n=5;
            if nargin<1
                m=5;
            else
                m=varargin{1};
            end
        else
            n=varargin{2};
        end
    else
        H=varargin{3};
    end
else
    p=varargin{4};
end

predicate=[myrand(m,p,1) myrand(n,p,1) myrand(H,p,1)];

