function [challenges,rtables,responses,predicate]=GenerateSession(predicate,nr,m,n,H,l,p)
% [challenges,rtables,responses,predicate]=GenerateSession(predicate,m,n,H,l,p)
% Generate a random authentication session (nr challengs and nr randomized correct responses).
% The output is a lXnr cell matrix for challengs, a 1Xnr cell matrix for
% response tables, a 1Xnr cell matrix for responses, and probably also a
% randomly generated predicate.
%
% Developer: Shujun Li @ www.hooklee.com, 2009.

if nargin<7
    p=2;
    if nargin<6
        l=2;
        if nargin<5
            H=26;
            if nargin<4
                n=5;
                if nargin<3
                    m=5;
                    if nargin<2
                        nr=5;
                        if nargin<1
                            predicate=GeneratePredicate(m,n,H,p);
                        end
                    end
                end
            end
        end
    end
end

challenges=[];
rtables=[];
if p~=2
    disp('GenerateResponseTable: only p=2 is supported in the current edition!');
    return;
end

challenges=cell(1,nr);
rtables=cell(1,nr);
responses=cell(1,nr);
disp('===Predicate===');
DisplayPredicate(predicate);
for r=1:nr
    fprintf('====Challenge %d====\n',r);
    challenges{r}=GenerateChallenge(predicate,m,n,H,l);
    DisplayChallenge(challenges{r});
    response_hidden=GetHiddenResponse(predicate,challenges{r});
    disp('--Response Table--');
    rtables{r}=GenerateResponseTable(l);
    DisplayResponseTable(rtables{r});
    responses{r}=rtables{r}{response_hidden(1)+1,response_hidden(2)+1};
    fprintf('The correct response should be %s.\n', responses{r});
end
