function response_hidden=GetHiddenResponse(predicate,challenge)
% response_hidden=GetHiddenResponse(predicate,challenge)
% Get the hidden response of the user to a given predicate and a given
% challenge.
%
% Developer: Shujun Li @ www.hooklee.com, 2009.

response_hidden=[];
if nargin<2
    disp('GetHiddenResponse: two input parameters are required!');
    return;
end
predicate_s=size(predicate);
if numel(size(predicate_s))~=2
    disp('GetHiddenResponse: the first input argument should be of dimension 2!');
    return;
end
if predicate_s(2)~=3
    disp('GetHiddenResponse: the first input argument should be a pX3 array!');
    return;
end
challenge_s=size(challenge);
if numel(challenge_s)~=3
    disp('GetHiddenResponse: the second input argument should be of dimension 3!');
    return;
end

[m n l]=size(challenge);

response_hidden=zeros(1,2);
for i=1:2
    for j=1:l
        if ismember(predicate(i,3),challenge{predicate(i,1),predicate(i,2),j})
            response_hidden(i)=response_hidden(i)+bitset(0,j);
        end
    end
end
