function rho=GetPrRho(M,H,p,l,nr)
% rho=GetPrRho(M,H,p,l,nr)
% Calculate the probability rho shown in Eq. (2) of our paper.
%
% Developer: Shujun Li @ www.hooklee.com, 2009.

N1=(M*H)^p-1;
Hp=H^p;
lnr2=2^(-l*nr);
a=0:N1;
rho0s=rho0(N1,Hp,a);
rho=sum(rho0s.*binopdf(a,N1,lnr2));
% rho=sum((1-(1-Hp/N1).^a).*binopdf(a,N1,lnr2));

function y=rho0(N1,Hp,a)

N1_Hp=N1-Hp;
n_a=numel(a);
y=ones(1,n_a);
for i=1:n_a
    if (a(i)>0 && a(i)<=N1_Hp)
        y(i)=1-prod(1-Hp./(N1-(0:a(i)-1)));
        if y(i)==1
            break; % y(i)=1 => y(i+1)=1
        end
    end
    if mod(i,1000)==0
        fprintf('y(%d)=%g (%g%%)\n',i,y(i),100*i/N1);
    end
end
