function y=GetRankingPr(M,H,p,l,nr,t)
% y=GetRankingPr(M,H,p,l,nr,t)
% Calculate the ranking probability as shown in Eq. (3) of our paper.
%
% Developer: Shujun Li @ www.hooklee.com, 2009.

rho=0.4833961;

N=M^p;
N_1=N-1;
N1=(M*H)^p-1;
L=round(t*rho^t*N1/2^(l*nr));
if L<=t
    y=1;
    return;
end
% q1=(H^p-1)/N1;
q0=H^p/N1;

y2=0;
for i=t+1:L
    y2=y2+combination_q(L,q0,i)*(1-q0)^(L-i);
    % y2=y2+combination_q(L,q0,i);
end
y=1-min(1,N_1*y2);

function y=combination_q(L,q,L1)

Ls=(L:-1:L-L1+1);
L1s=(L1:-1:1);
y=1;
for i=1:L1
    y=y*Ls(i)*q/L1s(i);
end
