function cell_index=Predicate2CellIndex(varargin)
% cell_index=Predicate2CellIndex(predicate,m,n)
% cell_index=Predicate2CellIndex([m1,n1;m2,n2],m,n)
% cell_index=Predicate2CellIndex(m1,n1,m2,n2,m,n)
% Transform a predicate to a cell index (represented as an
% integer to ease comparison)
%
% Developer: Shujun Li @ www.hooklee.com, 2009.

cell_index=[];

if nargin<1
    disp('PredicatesSet2CellIndices: at least one input argument is needed!');
    return;
end

s=numel(varargin{1});

if s>=4 % predicate=[m1 n1 H1;m2 n2 H2] or [m1,n1;m2,n2]
    m1=varargin{1}(1);
    m2=varargin{1}(2);
    n1=varargin{1}(3);
    n2=varargin{1}(4);
    if nargin<3
        n=5;
    else
        n=varargin{3};
    end
    if nargin<2
        m=5;
    else
        m=varargin{2};
    end
elseif s==1 % m1,n1,m2,n2
    if nargin<4
        disp('PredicatesSet2CellIndices: too few input arguments!');
        return;
    end
    m1=varargin{1};
    n1=varargin{2};
    m2=varargin{3};
    n2=varargin{4};
    if nargin<3
        n=5;
    else
        n=varargin{3};
    end
    if nargin<2
        m=5;
    else
        m=varargin{2};
    end
else
    disp('PredicatesSet2CellIndices: the first input argument is invalid!');
    return;
end

cell_index=n*(m*(n*(m1-1)+(n1-1))+(m2-1))+(n2-1);
