function secret_character=Predicate2SecretCharacter(varargin)
% secret_character=Predicate2SecretCharacter(predicate,H)
% secret_character=Predicate2SecretCharacter([H1;H2],H)
% secret_character=Predicate2SecretCharacter([H1 H2],H)
% secret_character=Predicate2SecretCharacter(H1,H2,H)
% Transform a set of predicates to a set of secret character pairs 
% (represented as integers to ease comparison)
%
% Developer: Shujun Li @ www.hooklee.com, 2009.

secret_character=[];

if nargin<1
    disp('Predicate2SecretCharacter: at least one input argument is needed!');
    return;
end

s=numel(varargin{1});

if s>=2
    if s>=6 % predicate=[m1 n1 H1;m2 n2 H2]
        H1=varargin{1}(5); % (1,3)
        H2=varargin{1}(6); % (2,3
    else % [H1;H2] or [H1 H2]
        H1=varargin{1}(1);
        H2=varargin{1}(2);
    end
    if nargin<2
        H=26;
    else
        H=varargin{2};
    end
elseif s==1 % H1,H2
    if nargin<2
        disp('PredicatesSet2CellIndices: too few input arguments!');
        return;
    else
        H1=varargin{1};
        H2=varargin{2};
        if nargin<3
            H=26;
        else
            H=varargin{3};
        end
    end
else
    disp('PredicatesSet2CellIndices: the first input argument is invalid!');
    return;
end

secret_character=H*(H1-1)+(H2-1);
