function cell_indices=PredicatesSet2CellIndices(predicates_set,m,n)
% cell_indices=PredicatesSet2CellIndices(predicates_set,m,n)
% Transform a set of predicates to a set of cell indicies (represented as
% integers to ease comparison)
%
% Developer: Shujun Li @ www.hooklee.com, 2009.

if nargin<3
    m=5;
    if nargin<2
        n=5;
        if nargin<1
            disp('PredicatesSet2CellIndices: at least one input argument is needed!');
            return;
        end
    end
end

s=numel(predicates_set);

cell_indices=zeros(1,s);
for i=1:s
    predicate=predicates_set{i}-1; % change to 0-based numbers
    cell_indices(i)=n*(m*(n*predicate(1,1)+predicate(1,2))+predicate(2,1))+predicate(2,2);
end
