function secret_characters=PredicatesSet2SecretCharacters(predicates_set,H)
% secret_chars=PredicatesSet2SecretCharacters(predicates_set,H)
% Transform a set of predicates to a set of secret character pairs 
% (represented as integers to ease comparison)
%
% Developer: Shujun Li @ www.hooklee.com, 2009.

if nargin<2
    H=26;
    if nargin<1
        disp('PredicatesSet2SecretCharacters: one input argument is needed!');
        return;
    end
end

s=numel(predicates_set);

secret_characters=zeros(1,s);
for j=1:s
    secret_characters(j)=H*(predicates_set{j}(1,3)-1)+(predicates_set{j}(2,3)-1);
end
