function predicates_sets_refined=RefinePredicatesSetsI(predicates_sets,I)
% predicates_sets_refined=RefinePredicatesSetsI(predicates_sets,I)
% Refine a number of predicate sets according to the values of I.
%
% Developer: Shujun Li @ www.hooklee.com, 2009.

predicates_sets_refined=[];

if nargin<2
    disp('RefinePredicatesSetsI: two input arguments are needed!');
    return;
end

na=numel(predicates_sets);
predicates_sets_refined=cell(1,na);

s=zeros(1,na);
for i=1:na
    s(i)=numel(predicates_sets{i});
end

I_unique=unique(I);
s_I_unique=numel(I_unique);

for i=1:s_I_unique
    index=find(I(1:na)==I_unique(i));
    if isempty(index)
        continue;
    end
    s_index=numel(index);
    if s_index==1
        predicates_sets_refined{index(1)}=predicates_sets{index(1)};
        continue;
    end
    % Get the intersection of all the predicate sets.
    ps_r=predicates_sets{index(1)};
    for j=2:s_index
        ps_r=IntersectPredicates(ps_r,predicates_sets{index(j)});
    end
    % Set the intersection as the new predicate sets.
    % We do NOT remove s_index-1 predicate sets, because this may cause
    % trouble when we want to do some postprocessing again on those
    % predicate sets.
    for j=1:s_index
        predicates_sets_refined{index(j)}=ps_r;
    end
end
