function y=Seconds2TimeStr(s)
% y=Seconds2TimeStr(s)
% Transform a period of time to a string.
% The input argument s is the number of seconds, and is normally obtained
% from t0=cputime and cputime-t0.
% The output is a string of time in one of the following formats
% "10 days, 11h:11m:11s" (when s>= 1 day)
% "11h:11m:11s" (when 1 hour <= s < 1 day)
% "11m:11s" (when 1 minute <= s < 1 hour)
% "11 seconds" (when s < 1 minute)
%
% Developer: Shujun Li @ www.hooklee.com, 2009.

y(3)=rem(s,60);
s=floor(s/60);
y(2)=rem(s,60);
y(1)=floor(s/60);
d=floor(y(1)/24);
y(1)=rem(y(1),24);
if d>1
    y=sprintf('%d days, %02dh:%02dm:%.2gs',d,y);
elseif d==1
    y=sprintf('%d day, %02dh:%02dm:%.2gs',d,y);
elseif y(1)>0
    y=sprintf('%02dh:%02dm:%.2gs',y);
elseif y(2)>0
    y=sprintf('%02dm:%.2gs',y(2:3));
else
    y=sprintf('%.2g seconds',y(3));
end
