function y=myrand(n,varargin)
% y=myrand(n,...)
% Generate a s1Xs2 random matrix in the range {1,2,...,n}
% When n<=0, output an all-zero matrix.
% When n=1, output an all-one matrix.
%
% Input parameters:
% n: the maximal value of output (default: 2).
% varargin: other arguments that will be directly forwarded to rand().
%
% Developer: Shujun Li @ www.hooklee.com, 2009.

if nargin<1
    n=2;
end

if n<=0
    y=zeros(s1,s2);
elseif n==1
    y=ones(s1,s2);
else
    y=ceil(n*rand(varargin{:}));
    y(find(y==0))=1;
end
